 
#include "stdafx.h"
#include "VisioDraw.h"
#include "WorkspaceBar.h"
#include "VisioDrawDoc.h"
#include "VisioDrawView.h"
 
/////////////////////////////////////////////////////////////////////////////
// CWorkspaceBar

BEGIN_MESSAGE_MAP(CWorkspaceBar, CDockablePane)
	//{{AFX_MSG_MAP(CWorkspaceBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
 
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(WM_FOPSTYLE_CLICKED, OnViewValidMsg)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWorkspaceBar construction/destruction

CWorkspaceBar::CWorkspaceBar()
{
	 
}

CWorkspaceBar::~CWorkspaceBar()
{
	m_wndDlgBar.ClearAll();
}

/////////////////////////////////////////////////////////////////////////////
// CWorkspaceBar message handlers

int CWorkspaceBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDockablePane::OnCreate(lpCreateStruct) == -1)
		return -1;

 
	CRect rectDummy;
	rectDummy.SetRectEmpty ();

	// Create tabs window:
	if (!m_wndTabs.Create (CMFCTabCtrl::STYLE_FLAT, rectDummy, this, 1, CMFCTabCtrl::LOCATION_TOP))
	{
		TRACE0("Failed to create workspace tab window\n");
		return -1;      // fail to create
	}

	m_wndTabs.HideActiveWindowHorzScrollBar();
//	m_wndTabs.SetImageList (IDB_WORKSPACE, 16);

	m_wndTool.Create(WS_CHILD|WS_VISIBLE|WS_EX_CLIENTEDGE,CRect(0,0,100,100),&m_wndTabs,1232);
	m_wndTool.m_bCoolMode = TRUE;
	m_wndTool.m_strCaption = _T("Basic");

	dlgFill.Create(IDD_DIALOG_SHAPE_PROP,&m_wndTabs);
	dlgLine.Create(IDD_DIALOG_SHAPE_PROP2,&m_wndTabs);

	m_wndDlgBar.SetStyleMode();
	m_wndDlgBar.Create(WS_CHILD|WS_VISIBLE|WS_EX_CLIENTEDGE,CRect(0,0,100,100),&m_wndTabs,1216);
	AddInfoToTab();
 
	// Attach tree windows to tab:
	
	m_wndTabs.AddTab (&dlgFill, _T("Fill"), 0 /* Image number */);
	m_wndTabs.AddTab (&dlgLine, _T("Line"), 0 /* Image number */);
	m_wndTabs.AddTab (&m_wndTool, _T("Draw"), 1 /* Image number */);
	m_wndTabs.AddTab (&m_wndDlgBar, _T("Style"), 2 /* Image number */);
	
	
	return 0;
}

void CWorkspaceBar::UpdateBar()
{
	m_wndDlgBar.ClearAll();
	AddInfoToTab();
	m_wndDlgBar.UpdateControl();
}

void CWorkspaceBar::AddInfoToTab()
{
	CFOPShapeDefaultStyle *pLay = NULL;
	POSITION pos = gfxDefStyleData.GetDefStyleList()->GetHeadPosition();
	while(pos != NULL)
	{
		pLay = (CFOPShapeDefaultStyle *)gfxDefStyleData.GetDefStyleList()->GetNext(pos);
		
		if(pLay != NULL)
		{
			CString strPath = pLay->GetItemCaption();
			CString strTitle = pLay->GetItemCaption();
			
			CFOModelBoxItem *pItem = m_wndDlgBar.AddNewItem();
			pItem->SetCaption(strTitle);
			pItem->SetLinkFileName(strPath);
			
			
		}
	}
	
}
class CFOPExtToolCmdUI : public CCmdUI
{
public:
	virtual void Enable(BOOL bOn);
	virtual void SetCheck(int nCheck);
	virtual void SetText(LPCTSTR lpszText);
};

void CFOPExtToolCmdUI::Enable(BOOL bOn)
{
	m_bEnableChanged = TRUE;
	
	CWorkspaceBar * pToolBar = (CWorkspaceBar *) m_pOther;
	ASSERT(pToolBar != NULL);
 	
	CFOPExtToolBarItem * pSBP = pToolBar->m_wndTool.GetItemAt(m_nIndex);
	if(pSBP == NULL)
	{
		return;
	}
	
	BOOL bOld = pSBP->m_bDisable;
	
	if(!bOn)
		pSBP->m_bDisable = TRUE;
	else
		pSBP->m_bDisable = FALSE;
	
	if(pSBP->m_bDisable != bOld)
	{
		pToolBar->m_wndTool.InvalItem(pSBP);
	}
	
}

void CFOPExtToolCmdUI::SetCheck(int nCheck)
{
	ASSERT(nCheck >= 0 && nCheck <= 2);
	
	CWorkspaceBar * pToolBar = (CWorkspaceBar *) m_pOther;
	ASSERT(pToolBar != NULL);
 	
	CFOPExtToolBarItem * pSBP = pToolBar->m_wndTool.GetItemAt(m_nIndex);
	if(pSBP == NULL)
	{
		return;
	}
	
	BOOL bOld = pSBP->m_bHitLast;
	
	if(nCheck <= 0)
		pSBP->m_bHitLast = FALSE;
	else if(nCheck == 1 || nCheck == 2)
		pSBP->m_bHitLast = TRUE;
	
	if(pSBP->m_bHitLast != bOld)
	{
		pToolBar->m_wndTool.InvalItem(pSBP);
	}
	
}

void CFOPExtToolCmdUI::SetText(LPCTSTR /* lpszText */)
{
}

BOOL CWorkspaceBar::LoadToolBar(UINT nIDResource)
{
	
	return m_wndTool.LoadToolBar(nIDResource);
}

LRESULT CWorkspaceBar::OnViewValidMsg (WPARAM wparam, LPARAM lp)
{
	lp;
	int nType= (int) wparam;
	CString str((TCHAR*)lp);
 
	if(!str.IsEmpty())
	{
		CFOPShapeDefaultStyle *pStyle = gfxDefStyleData.GetStyle(str);
		if(pStyle != NULL)
		{
			CVisioDrawView* pView = (CVisioDrawView*)FOGetActiveView();
			if(pView != NULL)
			{
				pView->UpdateStyle(pStyle);
			}
		}
	}
	
	return 1;
}

BOOL CWorkspaceBar::AddToolBar(UINT nID, CString strTitle)
{
	return m_wndTool.AddToolBar(nID, strTitle);
}

void CWorkspaceBar::OnUpdateCmdUI(CFrameWnd * pTarget,BOOL bDisableIfNoHndler)
{
	if(!m_wndTool.m_bCoolMode)
		return;
	
	CFOPExtToolCmdUI state;
	state.m_pOther = this;
	state.m_nIndexMax = m_wndTool.GetSize();
	
	for(state.m_nIndex = 0; state.m_nIndex < state.m_nIndexMax; state.m_nIndex ++)
	{
		CFOPExtToolBarItem * pSBP = m_wndTool.GetItemAt(state.m_nIndex);
		if(pSBP == NULL)
		{
			return;
		}
		BOOL bDis = pSBP->m_bDisable;
		
		state.m_nID = pSBP->m_nObjType;
		state.DoUpdate(pTarget,bDis ? 0 : bDisableIfNoHndler);
		
	}
	
}

void CWorkspaceBar::OnSize(UINT nType, int cx, int cy) 
{
	CDockablePane::OnSize(nType, cx, cy);
	AdjustLayout ();
}
 

static BOOL bIsThree = TRUE;
  
void CWorkspaceBar::AdjustLayout ()
{
	CRect rectClient;
	GetClientRect (rectClient);

	int cyTlb = 0;
 
	m_wndTabs.SetWindowPos (NULL, 0, cyTlb, rectClient.Width (), rectClient.Height () - cyTlb,
							SWP_NOACTIVATE | SWP_NOZORDER);
}
 
